// =====================================================================
/*!
//
//  \file TOutputObjectStream.hh
//  \brief This file contains the TOutputObjectStream class.
//  \author Go IWAI <goiwai@users.sourceforge.jp>
//
//  $Id: TOutputObjectStream.hh,v 1.5 2003/12/06 10:56:19 goiwai Exp $
//  $Name: CLDAQ-1-11-00 $
//  $Log: TOutputObjectStream.hh,v $
//  Revision 1.5  2003/12/06 10:56:19  goiwai
//  フィルタ関連の修整と Read(),Write()の戻り値の修整です.
//  Read()もWrite()も処理したレコードサイズを返します.
//  フィルタがある場合も同様です.
//  それぞれのストリームのDataSizeの扱いですが,これは扱ったレコードサイズ
//  でなく扱ったファイルやソケットなどのサイズになります.レコードサイズと
//  一致するとは限りません.
//
//  Revision 1.4  2003/11/03 08:35:13  goiwai
//  Doxygen用のタグとコメントをうちこんでいく試みを開始しました.
//
//  Revision 1.3  2003/10/06 17:02:42  goiwai
//  *** empty log message ***
//
//  Revision 1.2  2003/07/30 16:19:31  goiwai
//  ファイルにコミットログをつけることにしました.
//
*/
// =====================================================================
#ifndef __TOUTPUTOBJECTSTREAM_HH
#define __TOUTPUTOBJECTSTREAM_HH

#include "Tglobals.h"
#include "TObjectStream.hh"

class TStreamableObject;
class TOutputObjectFilter;


/*!
// \example
//
// If example code exists.
//
*/

/*!
// \class TOutputObjectStream
// \brief This is the TOutputObjectStream class.
// \author Go IWAI <goiwai@users.sourceforge.jp>
//
// The TOutputObjectStream class detail description.
// Write it down ASAP!
//
// \todo None?
// \bug None?
// \ingroup PersistencyCategory
*/
class TOutputObjectStream
  : public TObjectStream
{

  protected:
    TOutputObjectFilter* theObjectFilter;

  public:
    TOutputObjectStream( Tstream_t streamtype = tUnknownStream );
    TOutputObjectStream( TOutputObjectFilter* filter, Tstream_t streamtype = tUnknownStream );

  protected:
    virtual ~TOutputObjectStream();

  public:
    TOutputObjectFilter* GetObjectFilter() const;
    Tvoid SetObjectFilter( TOutputObjectFilter* filter );
    Tbool HasFilter() const;

  public:
    virtual Tint Write( TStreamableObject& object ) = 0;
    friend Tint operator<<( TOutputObjectStream& left, TStreamableObject& object );
    friend Tint operator<<( TOutputObjectStream& left, const TStreamableObject& object );

};

inline Tint operator<<( TOutputObjectStream& left, TStreamableObject& object )
{
  return left.Write( object );
}

inline Tint operator<<( TOutputObjectStream& left, const TStreamableObject& object )
{
  return left.Write( *(TStreamableObject*)(&object) );
}

inline TOutputObjectFilter* TOutputObjectStream::GetObjectFilter() const
{
  return theObjectFilter;
}

inline Tvoid TOutputObjectStream::SetObjectFilter( TOutputObjectFilter* filter )
{
  theObjectFilter = filter;
  return;
}

inline Tbool TOutputObjectStream::HasFilter() const
{
  return ( theObjectFilter != 0 ) ? Ttrue : Tfalse;
}

#endif
